# Detect where the pam modules are
%global _pamlibdir %(eval "rpm -qf %{_libdir}/security 2> /dev/null | %{__grep} -q ^pam && echo %{_libdir} || echo /%{_lib}")

# Do we have new pam without pam_stack
%global use_pam_include %(eval [ $(rpm -q --queryformat '%{VERSION}' pam | %{__sed} -e "s/\\.//g") -ge 80 ] && echo 1 || echo 0 )

Summary: PAM module that provides support for One Time Passwords (OTP) authentication
Name: pam_sotp
Version: 0.3.3
Release: 9%{?dist}
License: GPLv2+
Group: System Environment/Base
URL: http://www.cavecanen.org/cs/projects/pam_sotp/
Packager: Simon Matter <simon.matter@invoca.ch>
Vendor: Invoca Systems
Distribution: Invoca Linux Server
Source0: http://www.cavecanen.org/cs/projects/%{name}/dl/%{name}-%{version}.tar.bz2
Source1: pam_sotp-pam-config_stack
Source2: pam_sotp-pam-config_include
Source3: pam_sotp-README.RPM
Patch0: pam_sotp-0.3.3-no_shadow_group.patch
Patch1: pam_sotp-0.3.3-gcc_ld.patch
Patch2: pam_sotp-0.3.3-no_lib_security_check.patch
BuildRequires: pam-devel, sed
BuildRoot: %{_tmppath}/%{name}-%{version}-root

%description
Pam_sotp provides a simple one time password mechanism for Linux-PAM
(Pluggable Authentication Modules).

Pam_sotp is still under early stages of development. Although it
seems to work pretty good be warned that this software could contain
severe bugs that may put at risk the security of your system. Until
a stable release is reached you are advised to not use pam_sotp on
mission-critical systems or production servers.

%prep
%setup -q
%patch0 -p1 -b .shadow
%patch1 -p1 -b .gcc_ld
%patch2 -p1 -b .no_lib_security_check

%build
%configure --with-randomdev=/dev/urandom
%{__make}

%install
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%{__install} -d %{buildroot}%{_pamlibdir}/security
%{__install} -d %{buildroot}%{_bindir}
%{__install} -d %{buildroot}%{_sysconfdir}/pam.d
%{__install} -d -m 0770 %{buildroot}%{_sysconfdir}/sotp

%{__make} install DESTDIR=%{buildroot} INSTALL="install -p" pam_moduledir=%{_pamlibdir}/security

%if %{use_pam_include}
%global pam_cfg %{SOURCE2}
%else
%global pam_cfg %{SOURCE1}
%endif
%{__install} -m 0644 -p %{pam_cfg} %{buildroot}%{_sysconfdir}/pam.d/otppasswd
%{__install} -m 0644 -p %{SOURCE3} README.RPM

%clean
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog COPYING NEWS README*
%doc doc/manual/html doc/manual/pdf
%{_pamlibdir}/security/%{name}.so
%{_sysconfdir}/pam.d/otppasswd
%{_sysconfdir}/sotp
%attr(2755,root,root) %{_bindir}/otppasswd

%changelog
* Mon Jan 10 2022 Simon Matter <simon.matter@invoca.ch> 0.3.3-9
- add support for EL9

* Thu Apr 23 2020 Simon Matter <simon.matter@invoca.ch> 0.3.3-8
- fix module location on EL8

* Wed Apr 22 2020 Simon Matter <simon.matter@invoca.ch> 0.3.3-7
- add support for EL8

* Tue Dec 16 2014 Simon Matter <simon.matter@invoca.ch> 0.3.3-6
- fix building on el7

* Tue Aug 02 2011 Simon Matter <simon.matter@invoca.ch> 0.3.3-5
- fix patch to build as non root

* Fri Apr 15 2011 Simon Matter <simon.matter@invoca.ch> 0.3.3-4
- mass rebuild

* Thu Feb 11 2010 Simon Matter <simon.matter@invoca.ch> 0.3.3-3
- add patch to link with gcc
- change license tag to GPLv2+

* Wed Feb 06 2008 Simon Matter <simon.matter@invoca.ch> 0.3.3-2
- fix pam security directory on x86_64

* Tue Dec 26 2006 Simon Matter <simon.matter@invoca.ch> 0.3.3-1
- initial build
